<?php

if(file_exists('0.3.db')){
    echo 'file exists';
    return false;
}

function db_create_schema($dbh)
{
    $sql = <<<EOS
CREATE TABLE tasks(
id                       INTEGER,
revision_id              INTEGER DEFAULT 0,
accept_date              INTEGER,
accept_person            TEXT,
applicant                TEXT,
content                  TEXT,
deleted                  INTEGER DEFAULT 0,
update_date              INTEGER,
remote_addr              TEXT,
PRIMARY KEY(id, revision_id)
)
EOS;

    $res = $dbh->exec($sql);
    if(!$res){
        // print_r($dbh->errorInfo());
    }

    $sql = <<<EOS
CREATE TABLE tickets(
id                       INTEGER,
revision_id              INTEGER DEFAULT 0,
task_id                  INTEGER,
person                   TEXT,
content                  TEXT,
estimate_time            REAL,
results_time             REAL,
completion_date          INTEGER,
deleted                  INTEGER DEFAULT 0,
update_date              INTEGER,
remote_addr              TEXT,
PRIMARY KEY(id, revision_id)
)
EOS;

    $res = $dbh->exec($sql);
    if(!$res){
        // print_r($dbh->errorInfo());
    }

    $sql = <<<EOS
CREATE VIEW valid_tasks AS
SELECT
 *
FROM
 (
 SELECT
  t1.id AS id,
  MAX(t2.revision_id) AS revision_id
 FROM
  tasks t1
  LEFT JOIN tasks t2
  ON (t1.id=t2.id)
 GROUP BY
  t1.id
 ) AS t3
 LEFT JOIN tasks t
 ON t.id=t3.id AND t.revision_id=t3.revision_id

WHERE
 deleted=0
EOS;

    $res = $dbh->exec($sql);
    if(!$res){
        // print_r($dbh->errorInfo());
    }

    $sql = <<<EOS
CREATE VIEW valid_tickets AS
SELECT
 t.*
FROM
 (
 SELECT
  t1.id AS id,
  MAX(t2.revision_id) AS revision_id
 FROM
  tickets t1
  LEFT JOIN tickets t2
  ON (t1.id=t2.id)
 GROUP BY
  t1.id
 ) AS t3
 LEFT JOIN tickets t
  ON t.id=t3.id AND t.revision_id=t3.revision_id
 JOIN valid_tasks tasks
  ON t.task_id=tasks.id

WHERE
 t.deleted=0 AND tasks.deleted=0
EOS;

    $dbh->exec($sql);

}

$dsn_old = 'sqlite:' . dirname(__FILE__) . '/0.2.db';
$dsn_new = 'sqlite:' . dirname(__FILE__) . '/0.3.db';

$dbh_old = new PDO($dsn_old);
$dbh_new = new PDO($dsn_new);

// e[u̍쐬

db_create_schema($dbh_new);

// taskse[üڍs

$sql = 'SELECT * FROM tasks';
$sth = $dbh_old->prepare($sql);
if($sth === false){
    echo 'prepare error';
    return false;
}

$res = $sth->execute();
if($res === false){
    echo 'execute error';
    return false;
}

while(($task = $sth->fetch(PDO::FETCH_ASSOC)) !== false){
    $sql_ins = <<<EOS
INSERT INTO tasks
 (
 id,
 accept_date,
 accept_person,
 applicant,
 content,
 update_date) 
VALUES
 (
 :id,
 :accept_date,
 :accept_person,
 :applicant,
 :content,
 :update_date
 )
EOS;

    $sth_ins = $dbh_new->prepare($sql_ins);
    if($sth_ins === false){
        print_r( $dbh_new->errorInfo() );
        exit;
    }

    $params = array(
        ':id' => $task['id'],
        ':accept_date' => $task['accept_date'],
        ':accept_person' => $task['accept_person'],
        ':applicant' => $task['applicant'],
        ':content' => $task['content'],
        ':update_date' => $task['update_date']);

    $res_ins = $sth_ins->execute($params);
    if($res_ins === false){
        print_r( $dbh->errorInfo() );
        exit;
    }
}


// ticketse[üڍs

$sql = 'SELECT * FROM tickets';
$sth = $dbh_old->prepare($sql);
if($sth === false){
    echo 'prepare error';
    return false;
}

$res = $sth->execute();
if($res === false){
    echo 'execute error';
    return false;
}

while(($ticket = $sth->fetch(PDO::FETCH_ASSOC)) !== false){
    $sql_ins = <<<EOS
INSERT INTO tickets(
 id,
 task_id,
 person,
 content,
 estimate_time,
 results_time,
 completion_date,
 update_date)
VALUES (
 :id,
 :task_id,
 :person,
 :content,
 :estimate_time,
 :results_time,
 :completion_date,
 :update_date)
EOS;

    $sth_ins = $dbh_new->prepare($sql_ins);
    if($sth_ins === false){
        print_r( $dbh_new->errorInfo() );
        exit;
    }

    $params = array(
        ':id' => $ticket['id'],
        ':task_id' => $ticket['task_id'],
        ':person' => $ticket['person'],
        ':content' => $ticket['content'],
        ':estimate_time' => $ticket['estimate_time'],
        ':results_time' => $ticket['results_time'],
        ':completion_date' => $ticket['completion_date'],
        ':update_date' => $ticket['update_date']
        );

    $res_ins = $sth_ins->execute($params);
    if($res_ins === false){
        print_r( $dbh->errorInfo() );
        exit;
    }
}
